<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24" style="margin-top:10px">
            <Form v-show="searchOpen" :d="formId" :label-width="90" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="检定依据:" style="margin-left: -20px">
                <Input v-model="formObj.code" name="judgeBasis" placeholder="请输入检定依据" clearable @on-enter="_formSearch"/>
              </Form-item>
              <Form-item class="search-item" label="检定依据名称:">
                <Input v-model="formObj.basis"  name="judgeBasisName" placeholder="请输入检定依据名称" clearable @on-enter="_formSearch"/>
              </Form-item>
              <Form-item class="search-btn">
                <Button type="primary" @click="_formSearch">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">
            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" class="contHide"
                      @on-result-change="_btnClick"></btn-list>
          </Col>
          <!-- 表格 -->
          <Col span="24">
            <PTVXETable
              ref="pageTable"
              :form-id="formId"
              :table-height="tableHeight"
              :get-page="getPage"
              :icon-msg="iconMsg"
              @on-result-change="_tableResultChange">
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :width="item.width"
                :min-width="200"
                :fixed="item.fixed?item.fixed:undefined"
                sortable
              >
                <template slot-scope="scope">
                  <span v-if="item.dateTime">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd HH:MM:ss'):''}}</span>
                  <span v-else-if="item.image">
                     {{scope.row.picUri!==undefined?'是':'否'}}
                  </span>
                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
<!--    导入-->
    <!-- 添加、编辑 -->
    <importModal ref="importModal" @on-result-change="_page"></importModal>
    <MeterAptitudeManageEdit ref="editModal" @on-result-change="_page"></MeterAptitudeManageEdit>
    <sampleItemList ref="testItemModal" @on-result-change="_formSearch" />

    <imageTemplateImport ref="imageTemplateImport"   @on-result-change="_page"></imageTemplateImport>
  </div>
</template>

<script>
import { meterManage } from '../../../api'
import importModal from '../../../components/import/DownloadTemplateImport'
import imageTemplateImport from '../../../components/import/ImageTemplateImport'
import MeterAptitudeManageEdit from './MeterAptitudeManageEdit.vue'
import sampleItemList from './SampleItemList'
export default {
  name: 'MeterAptitudeManage',
  components: {
    MeterAptitudeManageEdit,
    sampleItemList,
    imageTemplateImport,
    importModal
  },
  data() {
    return {
      formId: 'meterAptitudeManageFormId',
      pageColumns: [
        { title: '授权仪器名称', key: 'name' },
        { title: '检定依据', key: 'code', width: 160 },
        { title: '检定依据名称', key: 'basis' },
        { title: '检定周期', key: 'cycle' },
        // {title: '限制范围或说明', key: 'limitDescription'},
        { title: '价格', key: 'price' },
        { title: '图片是否上传', key: 'picUri', image: true }
      ],
      btn: [
        { type: 'success', id: '', name: '添加' },
        { type: 'error', id: '', name: '删除' },
        { type: '', id: '', name: '导入' }
      ],
      iconMsg: [
        { type: 'md-create', id: '', name: '编辑' },
        { type: 'md-add', id: '', name: '上传仪器图片' },
        { type: 'md-image', id: '', name: '图片预览' },
        { type: 'md-trash', id: '', name: '删除' },
        { type: 'md-apps', id: '', name: '管理检测项目' }
      ],
      formObj: {
        basis: undefined,
        code: undefined
      },
      searchOpen: true,
      selectIds: [],
      getPage: {},
      typeData: []
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _btnClick(msg) {
      switch (msg) {
        case '添加':
          this._editModal(false)
          break
        case '删除':
          this._deleteSelected()
          break
        case '导入':
          this._import()
          break
        case '导出':
          this._export()
          break
        case 'search':
          this.searchOpen = !this.searchOpen
          break
      }
    },
    _iconClick(res, data) {
      switch (res) {
        case '编辑':
          this._editModal(true, data.id)
          break
        case '删除':
          this._deleteById(data.id)
          break
        case '管理检测项目':
          this.$refs.testItemModal._open(data.id)
          break
        case '上传仪器图片':
          this._uploadPic(data.id)
          break
        case '图片预览':
          this._lookPic(data)
          break
        case '操作日志':
          this._record(data.id)
          break
      }
    },
    _lookPic(data) {
      if (data.picUri) {
        window.open(data.picUri)
      } else {
        this.$Message.warning('暂无图片！')
      }
    },
    _uploadPic(id) {
      const action = '/meter/v1/aptitude/upload_?aptitudeId=' + id
      const data = {
        importUrl: action,
        downloadUrl: '',
        title: '上传'
      }
      this.$refs.imageTemplateImport._open(data, '上传图片')
    },

    _page: async function() {
      console.log(9522123)
      // this.$refs.pageTable._page('search-form-package', 'FoodJudgeBasis/page')
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      console.log('this.formObj', this.formObj)
      const result = await meterManage.page(this.formObj)
      if (result) {
        console.log(55555)
        console.log(result)
        this.getPage = result
        console.log(123456789)
        console.log(this.getPage)
        this.$refs.pageTable._hideLoading()
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this.getPage = this.$store.state.FoodJudgeBasis.page
          break
        case 'selectIds':
          this.selectIds = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._delete(ids)
        }
      })
    },
    _delete: async function(ids) {
      const result = await meterManage.deleteById(ids)
      if (result) {
        this._formSearch()
        this.$Message.success('删除成功！')
      }
    },
    _deleteById(id) {
      // 删除一条记录
      this._deleteByIds([id])
    },
    _deleteSelected() {
      // 批量删除
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this._deleteByIds(ids, '确定删除这 ' + ids.length + ' 条记录？')
      }
    },
    // 编辑&添加
    _editModal(edit, id) {
      if (edit) {
        this._getById(id)
        // 编辑
        // this.$store.dispatch('FoodJudgeBasis/getById', id).then(() => {
        //   this.$refs.editModal._open(this.$store.state.FoodJudgeBasis.model)
        // })
      } else {
        // 添加
        this.$refs.editModal._open()
      }
    },

    _getById: async function(id) {
      const result = await meterManage.getById(id)
      console.log('编辑结果')
      console.log(result)
      if (result) {
        this.$refs.editModal._open(result)
      }
    },
    // 导入
    _import() {
      const data = {
        importUrl: '/meter/v1/aptitude/import_aptitude',
        downloadUrl: '/meter/v1/excel/template/MeterAptitudeImport',
        title: '授权资质导入'
      }
      this.$refs.importModal._open(data, '授权资质导入')
    },
    // 导出
    _export() {
      console.log('.this.selectIds', this.selectIds)
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择需要导出的数据')
      } else {
        const content = '确定导出 ' + this.selectIds.length + ' 条记录？'
        this.$Modal.confirm({
          title: '提示',
          content: content,
          onOk: () => {
            // eslint-disable-next-line no-undef
            http.open(
              '/food/v1/food_aptitude_judge_basis/food_aptitude_judge_export?ids=' +
                this.selectIds
            )
          }
        })
      }
    }
  }
}
</script>

<style scoped>
</style>
